searchNodes=[{"doc":"Documentation for Circe .","ref":"Circe.html","title":"Circe","type":"module"},{"doc":"Handles the sigil ~m to match on code's ast. This is meant as a symmetric tool to quote/2 . The sigil should be used within a matching context: case/2 clause function head ( def/2 and fn/1 ) =/2 left hand side match?/2 's first argument You can directly match code: iex&gt; import Circe iex&gt; ast = quote do { :banana } end { :{} , [ ] , [ :banana ] } iex&gt; match? ( ~m/{:banana}/ , ast ) true You can ignore parts of the code by combining interpolation and an underscore: iex&gt; import Circe iex&gt; ast = quote do { :test_atom_pls_ignore } end { :{} , [ ] , [ :test_atom_pls_ignore ] } iex&gt; match? ( ~m/{ \#{ _ } }/ , ast ) true Instead of ignoring parts of the code, you can bind it to a variable: iex&gt; import Circe iex&gt; ~m/{ \#{ banana } }/ = quote do { :split } end { :{} , [ ] , [ :split ] } iex&gt; banana :split Sometime the ast that would correspond to the code you wrote is wrapped in a list, (typically concerning the -&gt; operator), you can unwrap it with the modifier w : iex&gt; import Circe iex&gt; ast = quote do case 4 do 1 -&gt; :one ; 2 -&gt; :two ; 3 -&gt; :three ; _ -&gt; :too_big end end iex&gt; ~m/case \#{ _ } do \#{ clauses } end/ = ast iex&gt; Enum . any? ( clauses , fn ~m/( \#{ _ } -&gt; :too_big)/ -&gt; true ; _ -&gt; false end ) false iex&gt; Enum . any? ( clauses , fn ~m/( \#{ _ } -&gt; :too_big)/w -&gt; true ; _ -&gt; false end ) true The equivalent to unquote_splicing/3 is \#{..._} : iex&gt; import Circe iex&gt; ~m/{ \#{ ... desserts } }/ = quote do { :banana , :split , :peach , :melba } end { :{} , [ ] , [ :banana , :split , :peach , :melba ] } iex&gt; desserts [ :banana , :split , :peach , :melba ] ... is parsed by Elixir as an identifier, so ...[whatever] will be parsed as key-based access to a data structure, to avoid problems, insert a space between ... and the opening bracket [ , for example ~m/def \#{... [head, [do: body]]}/","ref":"Circe.html#sigil_m/2","title":"Circe.sigil_m/2","type":"macro"},{"doc":"All notable changes to this project will be documented in this file.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Fixed Can now match on 2-tuples.","ref":"changelog.html#0-2-1-2022-12-03","title":"Changelog - 0.2.1 2022-12-03","type":"extras"},{"doc":"Added Spliced matching now uses ...x instead of [spliced: x] . Deprecated Spliced matching using [spliced: x] now prints a warning.","ref":"changelog.html#0-2-0-2022-05-14","title":"Changelog - 0.2.0 2022-05-14","type":"extras"},{"doc":"Added Base implementation Circe.sigil_m/2 : seems to work for all ASTs. (in hindsight, it didn't) Changelog format inspired by keep-a-changelog","ref":"changelog.html#0-1-0-2021-05-14","title":"Changelog - 0.1.0 - 2021-05-14","type":"extras"},{"doc":"Enchantress expert at transformation. This library aims at providing convenient tool for manipulating Elixir's AST. Currently there is only a sigil macro that help defining patterns in more declarative way. A few quick examples: iex(1)&gt; import Circe Circe iex(2)&gt; ~m/{:banana}/ = quote do { :banana } end { :{} , [ ] , [ :banana ] } iex(3)&gt; ~m/{ \#{ x } }/ = quote do { :banana } end { :{} , [ ] , [ :banana ] } iex(4)&gt; ~m/{ \#{ x } }/ = quote do { :banana , :split , :dessert } end ** (MatchError) no match of right hand side value: {:{}, [], [:banana, :split, :dessert]} iex(4)&gt; ~m/{ \#{ ... xs } }/ = quote do { :banana } end { :{} , [ ] , [ :banana ] } iex(5)&gt; xs [ :banana ] iex(6)&gt; ~m/{ \#{ x } }/ = quote do { :banana , :split } end ** (MatchError) no match of right hand side value: {:banana, :split} iex(6)&gt; ~m/{ \#{ ... x } }/ = quote do { :banana , :split } end ** (MatchError) no match of right hand side value: {:banana, :split} As can be seen from the last two examples, it's not yet possible to match on asts that can be literals when it's representation could also be an application. In the case here: 2-tuples are represented literally: {:banana, :split} = quote do {:banana, :split} end n-tuples (where n ≠ 2) are represented as an application {:{}, _, xs} when is_list(xs) = quote do {:a, :b, :c, :d} end No idea how to do that natively, we would need a way to merge multiple patterns into one. It should be possible with pattern synonyms though. (You can take a look at the package pattern_metonyms .)","ref":"readme.html","title":"Overview","type":"extras"}]